Package: org.apache.groovy.json.internal

## [Java] Class CharBuf

- org.apache.groovy.json.internal.CharBuf

- All Implemented Interfaces and Traits:
    CharSequence

      public class CharBuf
      extends Writer

  Authors:
    Rick Hightower

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected char[]` | `buffer` |
    `protected int` | `capacity` |
    `protected int` | `location` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CharBuf (char[] buffer)`
    `CharBuf (byte[] bytes)`
    `protected CharBuf (int capacity)`
    `protected CharBuf ()`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `_len(int location)`
    `` | `CharBuf` | `add(String str)`
    `` | `CharBuf` | `add(int i)`
    `` | `CharBuf` | `add(boolean b)`
    `` | `CharBuf` | `add(byte i)`
    `` | `CharBuf` | `add(short i)`
    `` | `CharBuf` | `add(long l)`
    `` | `CharBuf` | `add(double d)`
    `` | `CharBuf` | `add(float d)`
    `` | `CharBuf` | `add(char[] chars)`
    `` | `CharBuf` | `add(char[] chars, int length)`
    `` | `CharBuf` | `add(byte[] chars)`
    `` | `CharBuf` | `add(byte[] bytes, int start, int end)`
    `` | `CharBuf` | `add(char ch)`
    `` | `CharBuf` | `addBigDecimal(BigDecimal key)`
    `` | `CharBuf` | `addBigInteger(BigInteger key)`
    `` | `CharBuf` | `addBoolean(boolean b)`
    `` | `CharBuf` | `addByte(byte i)`
    `` | `CharBuf` | `addChar(byte i)`
    `` | `CharBuf` | `addChar(int i)`
    `` | `CharBuf` | `addChar(short i)`
    `` | `CharBuf` | `addChar(char ch)`
    `` | `CharBuf` | `addChars(char[] chars)`
    `` | `CharBuf` | `addDouble(double d)`
    `` | `CharBuf` | `addDouble(Double key)`
    `` | `CharBuf` | `addFloat(float d)`
    `` | `CharBuf` | `addFloat(Float key)`
    `` | `CharBuf` | `addInt(int i)`
    `` | `CharBuf` | `addInt(Integer key)`
    `` | `CharBuf` | `addJsonEscapedString(String jsonString)`
    `` | `CharBuf` | `addJsonEscapedString(String jsonString, boolean disableUnicodeEscaping)`
    `` | `CharBuf` | `addJsonEscapedString(char[] charArray)`
    `` | `CharBuf` | `addJsonEscapedString(char[] charArray, boolean disableUnicodeEscaping)`
    `` | `CharBuf` | `addJsonFieldName(String str)`
    `` | `CharBuf` | `addJsonFieldName(String str, boolean disableUnicodeEscaping)`
    `` | `CharBuf` | `addJsonFieldName(char[] chars)`
    `` | `CharBuf` | `addJsonFieldName(char[] chars, boolean disableUnicodeEscaping)`
    `` | `CharBuf` | `addLine(String str)`
    `` | `CharBuf` | `addLine(CharSequence str)`
    `` | `CharBuf` | `addLong(long l)`
    `` | `CharBuf` | `addLong(Long key)`
    `` | `void` | `addNull()`
    `` | `CharBuf` | `addQuoted(char[] chars)`
    `` | `CharBuf` | `addQuoted(String str)`
    `` | `CharBuf` | `addShort(short i)`
    `` | `CharBuf` | `addString(String str)`
    `` | `byte` | `byteValue()`
    `` | `char` | `charAt(int index)`
    `` | `void` | `close()`
    `` | `static CharBuf` | `create(int capacity)`
    `` | `static CharBuf` | `create(char[] buffer)`
    `` | `static CharBuf` | `createExact(int capacity)`
    `` | `CharBuf` | `decodeJsonString(char[] chars)`
    `` | `CharBuf` | `decodeJsonString(char[] chars, int start, int to)`
    `` | `double` | `doubleValue()`
    `` | `float` | `floatValue()`
    `` | `void` | `flush()`
    `` | `void` | `init()`
    `` | `int` | `intValue()`
    `` | `int` | `len()`
    `` | `int` | `length()`
    `` | `long` | `longValue()`
    `` | `char[]` | `readForRecycle()`
    `` | `void` | `recycle()`
    `` | `void` | `removeLastChar()`
    `` | `void` | `removeLastChar(char expect)`
    `` | `short` | `shortValue()`
    `` | `CharSequence` | `subSequence(int start, int end)`
    `` | `char[]` | `toCharArray()`
    `` | `String` | `toDebugString()`
    `` | `Number` | `toIntegerWrapper()`
    `` | `String` | `toString()`
    `` | `String` | `toStringAndRecycle()`
    `` | `void` | `write(char[] cbuf, int off, int len)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Writer` | `append, append, append, append, append, append, write, write, write, write, write, close, flush, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### protected char[] buffer

    - #### protected int capacity

    - #### protected int location

  - ### Constructor Detail

    - #### public CharBuf(char[] buffer)

    - #### public CharBuf(byte[] bytes)

    - #### protected CharBuf(int capacity)

    - #### protected CharBuf()

  - ### Method Detail

    - #### public void _len(int location)

    - #### public final CharBuf add(String str)

    - #### public final CharBuf add(int i)

    - #### public final CharBuf add(boolean b)

    - #### public final CharBuf add(byte i)

    - #### public final CharBuf add(short i)

    - #### public final CharBuf add(long l)

    - #### public final CharBuf add(double d)

    - #### public final CharBuf add(float d)

    - #### public CharBuf add(char[] chars)

    - #### public CharBuf add(char[] chars, int length)

    - #### public CharBuf add(byte[] chars)

    - #### public CharBuf add(byte[] bytes, int start, int end)

    - #### public final CharBuf add(char ch)

    - #### public CharBuf addBigDecimal(BigDecimal key)

    - #### public CharBuf addBigInteger(BigInteger key)

    - #### public final CharBuf addBoolean(boolean b)

    - #### public final CharBuf addByte(byte i)

    - #### public final CharBuf addChar(byte i)

    - #### public final CharBuf addChar(int i)

    - #### public final CharBuf addChar(short i)

    - #### public final CharBuf addChar(char ch)

    - #### public final CharBuf addChars(char[] chars)

    - #### public final CharBuf addDouble(double d)

    - #### public final CharBuf addDouble(Double key)

    - #### public final CharBuf addFloat(float d)

    - #### public final CharBuf addFloat(Float key)

    - #### public final CharBuf addInt(int i)

    - #### public final CharBuf addInt(Integer key)

    - #### public final CharBuf addJsonEscapedString(String jsonString)

    - #### public final CharBuf addJsonEscapedString(String jsonString, boolean disableUnicodeEscaping)

    - #### public final CharBuf addJsonEscapedString(char[] charArray)

    - #### public final CharBuf addJsonEscapedString(char[] charArray, boolean disableUnicodeEscaping)

    - #### public final CharBuf addJsonFieldName(String str)

    - #### public final CharBuf addJsonFieldName(String str, boolean disableUnicodeEscaping)

    - #### public final CharBuf addJsonFieldName(char[] chars)

    - #### public final CharBuf addJsonFieldName(char[] chars, boolean disableUnicodeEscaping)

    - #### public CharBuf addLine(String str)

    - #### public CharBuf addLine(CharSequence str)

    - #### public final CharBuf addLong(long l)

    - #### public final CharBuf addLong(Long key)

    - #### public final void addNull()

    - #### public final CharBuf addQuoted(char[] chars)

    - #### public final CharBuf addQuoted(String str)

    - #### public final CharBuf addShort(short i)

    - #### public final CharBuf addString(String str)

    - #### public byte byteValue()

    - #### public char charAt(int index)

    - #### public void close()

    - #### public static CharBuf create(int capacity)

    - #### public static CharBuf create(char[] buffer)

    - #### public static CharBuf createExact(int capacity)

    - #### public final CharBuf decodeJsonString(char[] chars)

    - #### public final CharBuf decodeJsonString(char[] chars, int start, int to)

    - #### public double doubleValue()

    - #### public float floatValue()

    - #### public void flush()

    - #### public void init()

    - #### public int intValue()

    - #### public int len()

    - #### public int length()

    - #### public long longValue()

    - #### public char[] readForRecycle()

    - #### public void recycle()

    - #### public void removeLastChar()

    - #### public void removeLastChar(char expect)

    - #### public short shortValue()

    - #### public CharSequence subSequence(int start, int end)

    - #### public char[] toCharArray()

    - #### public String toDebugString()

    - #### public Number toIntegerWrapper()

    - #### public String toString()

    - #### public String toStringAndRecycle()

    - #### public void write(char[] cbuf, int off, int len)